module BSTree where

data  BSTree a = Vazia | Nodo a (BSTree a) (BSTree a)
   deriving (Read,Show)

inorder, preorder, posorder :: BSTree a -> [a]

inorder Vazia = []
inorder (Nodo r e d) = (inorder e) ++ (r:(inorder d))

preorder Vazia = []
preorder (Nodo r e d) = r:((preorder e) ++ (preorder d))

posorder Vazia = []
posorder (Nodo r e d) = (posorder e) ++ (posorder d) ++ [r]

insere :: (Ord a) => BSTree a -> a -> BSTree a
insere Vazia x = Nodo x Vazia Vazia
insere (Nodo r e d) x | x < r     = Nodo r (insere e x) d
                      | otherwise = Nodo r e (insere d x)

invInorder, invPreorder, invPosorder :: (Ord a) => [a] -> BSTree a

invInorder a = l2BT (length a) a
 where l2BT 0 _ = Vazia
       l2BT n l = let m = div n 2
                      (e,(r:d)) = splitAt m l
                  in Nodo r (l2BT m e) (l2BT (n-m-1) d)

invPreorder = foldl insere Vazia

invPosorder = foldr (flip insere) Vazia

